
#ifndef __windows_inc__
#include "windows.inc"
#endif

class CObjectFile
{
	declare CObjectFile();
	declare _CObjectFile();

	declare AddSection(string SectionName, int SectionFlags),BOOL;
	declare AddSymbol(string SymbolName, int SectionIndex, void *SymbolData, int DataSize, opt BOOL DuplicateData),BOOL;
	declare Save(string path),BOOL;
	declare Cleanup();

	//private
	declare GetAligned(int value),int;
	declare AlignFileOffset(),int; // move (write nulls) file pointer to dword align
	declare WriteHeader();
	declare WriteSections();
	declare WriteSymbols();
	declare WriteStringTable();
	declare WriteRawData(int section);
	declare GetSectionStorage(int section),pointer; // index > 0
	declare GetStringTableSize(),int;
//	declare GetSectionDataSize(int section),int;

	IMAGE_FILE_HEADER m_header;   // NumberOfSections, OffsetToSymbolTable, NumberOfSymbols unknon
	CPointerList   m_sections; // SECTIONSTORAGE list
	CPointerList   m_symbols;  // SYMBOLSTORGE  list
	HANDLE         m_hFile;
	int            m_StringTableSize;
}