#ifndef __shldisp_inc__
#include "shldisp.inc"
#endif

#define AUTOCOMPLETE_FLAGS ACO_AUTOSUGGEST | ACO_UPDOWNKEYDROPSLIST

struct DIRNAME
{
	DIRNAME *next;
	WCHAR name[0];
}

class CEnumDirs
{
	declare CEnumDirs();
	declare DeleteList();
	declare OnDirectoryChanged(LPSTR path);
	declare virtual QueryInterface(REFIID *riid, void *ppvObject),HRESULT;
	declare virtual AddRef(),ULONG;
	declare virtual Release(),ULONG;
	declare virtual Next(ULONG celt, LPOLESTR *rgelt, ULONG *pceltFetched),HRESULT;
	declare virtual Skip(ULONG celt),HRESULT;
	declare virtual Reset(),HRESULT;
	declare virtual Clone(IEnumString *ppenum),HRESULT;
	int  m_refcnt;
	WIN32_FIND_DATAW m_wfd;
	DIRNAME *m_names;
	DIRNAME *m_current;

	dwstring m_szDirectory[MAX_PATH];
	int      m_cchDirectory;
}